<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.7"/>
<title>TI  Graph Library   (TIGL): Message&lt; DATA_TYPE, ID_TYPE &gt; Class Template Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { searchBox.OnSelectItem(0); });
</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td style="padding-left: 0.5em;">
   <div id="projectname">TI  Graph Library   (TIGL)
   &#160;<span id="projectnumber">ver1.0</span>
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.7 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li class="current"><a href="annotated.html"><span>Classes</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="annotated.html"><span>Class&#160;List</span></a></li>
      <li><a href="classes.html"><span>Class&#160;Index</span></a></li>
      <li><a href="hierarchy.html"><span>Class&#160;Hierarchy</span></a></li>
      <li><a href="functions.html"><span>Class&#160;Members</span></a></li>
    </ul>
  </div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
<a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(0)"><span class="SelectionMark">&#160;</span>All</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(1)"><span class="SelectionMark">&#160;</span>Classes</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(2)"><span class="SelectionMark">&#160;</span>Namespaces</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(3)"><span class="SelectionMark">&#160;</span>Files</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(4)"><span class="SelectionMark">&#160;</span>Functions</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(5)"><span class="SelectionMark">&#160;</span>Variables</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(6)"><span class="SelectionMark">&#160;</span>Enumerations</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(7)"><span class="SelectionMark">&#160;</span>Groups</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(8)"><span class="SelectionMark">&#160;</span>Pages</a></div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pro-attribs">Protected Attributes</a> &#124;
<a href="classMessage-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">Message&lt; DATA_TYPE, ID_TYPE &gt; Class Template Reference<div class="ingroups"><a class="el" href="group__interface__engine.html">Interface</a></div></div>  </div>
</div><!--header-->
<div class="contents">

<p>core data message class definition  
 <a href="classMessage.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="tiglAPIMessage_8hpp_source.html">tiglAPIMessage.hpp</a>&gt;</code></p>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:a7f00f7cf0526458792330a60979db9f1"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classMessage.html#a7f00f7cf0526458792330a60979db9f1">Message</a> ()</td></tr>
<tr class="memdesc:a7f00f7cf0526458792330a60979db9f1"><td class="mdescLeft">&#160;</td><td class="mdescRight">empty constructor  <a href="#a7f00f7cf0526458792330a60979db9f1">More...</a><br /></td></tr>
<tr class="separator:a7f00f7cf0526458792330a60979db9f1"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a607c353c056c6359ab048b7bdb8ec9ba"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classMessage.html#a607c353c056c6359ab048b7bdb8ec9ba">Message</a> (ID_TYPE &amp;tx, ID_TYPE &amp;rx, DATA_TYPE &amp;messContent)</td></tr>
<tr class="memdesc:a607c353c056c6359ab048b7bdb8ec9ba"><td class="mdescLeft">&#160;</td><td class="mdescRight">constructor of a message with all fields  <a href="#a607c353c056c6359ab048b7bdb8ec9ba">More...</a><br /></td></tr>
<tr class="separator:a607c353c056c6359ab048b7bdb8ec9ba"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a7998fabc85b28edae541ca123b293e40"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a7998fabc85b28edae541ca123b293e40"></a>
&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classMessage.html#a7998fabc85b28edae541ca123b293e40">~Message</a> ()</td></tr>
<tr class="memdesc:a7998fabc85b28edae541ca123b293e40"><td class="mdescLeft">&#160;</td><td class="mdescRight">destructor <br /></td></tr>
<tr class="separator:a7998fabc85b28edae541ca123b293e40"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ac9e7b0ec82d4c408ced91f34e44b3e8d"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="ac9e7b0ec82d4c408ced91f34e44b3e8d"></a>
ID_TYPE &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classMessage.html#ac9e7b0ec82d4c408ced91f34e44b3e8d">getSender</a> ()</td></tr>
<tr class="memdesc:ac9e7b0ec82d4c408ced91f34e44b3e8d"><td class="mdescLeft">&#160;</td><td class="mdescRight">returns the sender vertex <br /></td></tr>
<tr class="separator:ac9e7b0ec82d4c408ced91f34e44b3e8d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ac8f4ffba278ab0e5d29820dc82872d6a"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="ac8f4ffba278ab0e5d29820dc82872d6a"></a>
ID_TYPE &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classMessage.html#ac8f4ffba278ab0e5d29820dc82872d6a">getRcvr</a> ()</td></tr>
<tr class="memdesc:ac8f4ffba278ab0e5d29820dc82872d6a"><td class="mdescLeft">&#160;</td><td class="mdescRight">returns the destination vertex <br /></td></tr>
<tr class="separator:ac8f4ffba278ab0e5d29820dc82872d6a"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a57f18c305ece6cd53c0c02e08309a546"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a57f18c305ece6cd53c0c02e08309a546"></a>
DATA_TYPE &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classMessage.html#a57f18c305ece6cd53c0c02e08309a546">getContent</a> ()</td></tr>
<tr class="memdesc:a57f18c305ece6cd53c0c02e08309a546"><td class="mdescLeft">&#160;</td><td class="mdescRight">returns the message content <br /></td></tr>
<tr class="separator:a57f18c305ece6cd53c0c02e08309a546"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a03cd1893fc75256c319cba7d850f0dcd"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classMessage.html#a03cd1893fc75256c319cba7d850f0dcd">setMessage</a> (ID_TYPE &amp;tx, ID_TYPE &amp;rx, DATA_TYPE &amp;messContent)</td></tr>
<tr class="memdesc:a03cd1893fc75256c319cba7d850f0dcd"><td class="mdescLeft">&#160;</td><td class="mdescRight">preparing the full message fields  <a href="#a03cd1893fc75256c319cba7d850f0dcd">More...</a><br /></td></tr>
<tr class="separator:a03cd1893fc75256c319cba7d850f0dcd"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a38c93c3a1da92bd20e0a8f166c30b6b7"><td class="memTemplParams" colspan="2">template&lt;typename CMessages &gt; </td></tr>
<tr class="memitem:a38c93c3a1da92bd20e0a8f166c30b6b7"><td class="memTemplItemLeft" align="right" valign="top">void&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="classMessage.html#a38c93c3a1da92bd20e0a8f166c30b6b7">setMessage</a> (CMessages &amp;newMessage)</td></tr>
<tr class="memdesc:a38c93c3a1da92bd20e0a8f166c30b6b7"><td class="mdescLeft">&#160;</td><td class="mdescRight">copy from another message  <a href="#a38c93c3a1da92bd20e0a8f166c30b6b7">More...</a><br /></td></tr>
<tr class="separator:a38c93c3a1da92bd20e0a8f166c30b6b7"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ab7355583d37391bd699f3fca47073281"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classMessage.html#ab7355583d37391bd699f3fca47073281">setContent</a> (DATA_TYPE &amp;newContent)</td></tr>
<tr class="memdesc:ab7355583d37391bd699f3fca47073281"><td class="mdescLeft">&#160;</td><td class="mdescRight">set the message content  <a href="#ab7355583d37391bd699f3fca47073281">More...</a><br /></td></tr>
<tr class="separator:ab7355583d37391bd699f3fca47073281"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a3ddf04f2e6372501e0077170387d1723"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classMessage.html#a3ddf04f2e6372501e0077170387d1723">sumContent</a> (DATA_TYPE &amp;newContent)</td></tr>
<tr class="memdesc:a3ddf04f2e6372501e0077170387d1723"><td class="mdescLeft">&#160;</td><td class="mdescRight">sum new content to the current message content  <a href="#a3ddf04f2e6372501e0077170387d1723">More...</a><br /></td></tr>
<tr class="separator:a3ddf04f2e6372501e0077170387d1723"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a436d435e1a8bac5f8e127c3e1f164623"><td class="memTemplParams" colspan="2">template&lt;typename CMessages &gt; </td></tr>
<tr class="memitem:a436d435e1a8bac5f8e127c3e1f164623"><td class="memTemplItemLeft" align="right" valign="top">void&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="classMessage.html#a436d435e1a8bac5f8e127c3e1f164623">maxContent</a> (CMessages &amp;newMessage)</td></tr>
<tr class="memdesc:a436d435e1a8bac5f8e127c3e1f164623"><td class="mdescLeft">&#160;</td><td class="mdescRight">copy a new message content if its value is bigger than the current message content  <a href="#a436d435e1a8bac5f8e127c3e1f164623">More...</a><br /></td></tr>
<tr class="separator:a436d435e1a8bac5f8e127c3e1f164623"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a6356c7503304f26b38f819f64b10fbbb"><td class="memTemplParams" colspan="2">template&lt;typename CMessages &gt; </td></tr>
<tr class="memitem:a6356c7503304f26b38f819f64b10fbbb"><td class="memTemplItemLeft" align="right" valign="top">void&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="classMessage.html#a6356c7503304f26b38f819f64b10fbbb">minContent</a> (CMessages &amp;newMessage)</td></tr>
<tr class="memdesc:a6356c7503304f26b38f819f64b10fbbb"><td class="mdescLeft">&#160;</td><td class="mdescRight">copy a new message content if its value is smaller than the current message content  <a href="#a6356c7503304f26b38f819f64b10fbbb">More...</a><br /></td></tr>
<tr class="separator:a6356c7503304f26b38f819f64b10fbbb"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a357e66838738d2e656066406920a0262"><td class="memItemLeft" align="right" valign="top">uint_fast32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classMessage.html#a357e66838738d2e656066406920a0262">pack</a> (uint8_t *buf)</td></tr>
<tr class="memdesc:a357e66838738d2e656066406920a0262"><td class="mdescLeft">&#160;</td><td class="mdescRight">pack the content of the message to a uint8_t buffer. It is organized as : rcvr, sender, content  <a href="#a357e66838738d2e656066406920a0262">More...</a><br /></td></tr>
<tr class="separator:a357e66838738d2e656066406920a0262"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae23c04781f95e7c740d89861ebbca56d"><td class="memItemLeft" align="right" valign="top">uint_fast32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classMessage.html#ae23c04781f95e7c740d89861ebbca56d">unpack</a> (uint8_t *buf)</td></tr>
<tr class="memdesc:ae23c04781f95e7c740d89861ebbca56d"><td class="mdescLeft">&#160;</td><td class="mdescRight">unpack a packed message to get the message  <a href="#ae23c04781f95e7c740d89861ebbca56d">More...</a><br /></td></tr>
<tr class="separator:ae23c04781f95e7c740d89861ebbca56d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a2ed0c8d3abb07af98fd67362fffaacec"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a2ed0c8d3abb07af98fd67362fffaacec"></a>
uint_fast32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classMessage.html#a2ed0c8d3abb07af98fd67362fffaacec">sizeInBytes</a> ()</td></tr>
<tr class="memdesc:a2ed0c8d3abb07af98fd67362fffaacec"><td class="mdescLeft">&#160;</td><td class="mdescRight">returns message size in bytes <br /></td></tr>
<tr class="separator:a2ed0c8d3abb07af98fd67362fffaacec"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pro-attribs"></a>
Protected Attributes</h2></td></tr>
<tr class="memitem:a38d01ce6162b8e6ecf2dab14f0d72e5b"><td class="memItemLeft" align="right" valign="top">ID_TYPE&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classMessage.html#a38d01ce6162b8e6ecf2dab14f0d72e5b">sender</a></td></tr>
<tr class="separator:a38d01ce6162b8e6ecf2dab14f0d72e5b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a1e01d44a1fcd11eeeeb2166b8f772708"><td class="memItemLeft" align="right" valign="top">ID_TYPE&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classMessage.html#a1e01d44a1fcd11eeeeb2166b8f772708">rcvr</a></td></tr>
<tr class="separator:a1e01d44a1fcd11eeeeb2166b8f772708"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a9f969486b4146319e66d95ebbdbe9dae"><td class="memItemLeft" align="right" valign="top">DATA_TYPE&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classMessage.html#a9f969486b4146319e66d95ebbdbe9dae">content</a></td></tr>
<tr class="separator:a9f969486b4146319e66d95ebbdbe9dae"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><h3>template&lt;typename DATA_TYPE, typename ID_TYPE = uint_fast32_t&gt;<br />
class Message&lt; DATA_TYPE, ID_TYPE &gt;</h3>

<p>core data message class definition </p>
<p>It handles all the data message fields and processing It is a template class that is parameterized by </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">DATA_TYPE</td><td>the data field of the message </td></tr>
    <tr><td class="paramname">ID_TYPE</td><td>the type of the rx/tx vertex id </td></tr>
  </table>
  </dd>
</dl>
</div><h2 class="groupheader">Constructor &amp; Destructor Documentation</h2>
<a class="anchor" id="a7f00f7cf0526458792330a60979db9f1"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename DATA_TYPE , typename ID_TYPE &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classMessage.html">Message</a>&lt; DATA_TYPE, ID_TYPE &gt;::<a class="el" href="classMessage.html">Message</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>empty constructor </p>
<p>message fields have to be filled using public methods </p>

</div>
</div>
<a class="anchor" id="a607c353c056c6359ab048b7bdb8ec9ba"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename DATA_TYPE , typename ID_TYPE &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classMessage.html">Message</a>&lt; DATA_TYPE, ID_TYPE &gt;::<a class="el" href="classMessage.html">Message</a> </td>
          <td>(</td>
          <td class="paramtype">ID_TYPE &amp;&#160;</td>
          <td class="paramname"><em>tx</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">ID_TYPE &amp;&#160;</td>
          <td class="paramname"><em>rx</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">DATA_TYPE &amp;&#160;</td>
          <td class="paramname"><em>messContent</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>constructor of a message with all fields </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">tx</td><td>the sender vertex </td></tr>
    <tr><td class="paramname">rx</td><td>the receiver vertex </td></tr>
    <tr><td class="paramname">messContent</td><td>the message body </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<h2 class="groupheader">Member Function Documentation</h2>
<a class="anchor" id="a436d435e1a8bac5f8e127c3e1f164623"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename DATA_TYPE , typename ID_TYPE &gt; </div>
<div class="memtemplate">
template&lt;typename CMessages &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classMessage.html">Message</a>&lt; DATA_TYPE, ID_TYPE &gt;::maxContent </td>
          <td>(</td>
          <td class="paramtype">CMessages &amp;&#160;</td>
          <td class="paramname"><em>newMessage</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>copy a new message content if its value is bigger than the current message content </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">newMessage</td><td>reference to the other messages </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a6356c7503304f26b38f819f64b10fbbb"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename DATA_TYPE , typename ID_TYPE &gt; </div>
<div class="memtemplate">
template&lt;typename CMessages &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classMessage.html">Message</a>&lt; DATA_TYPE, ID_TYPE &gt;::minContent </td>
          <td>(</td>
          <td class="paramtype">CMessages &amp;&#160;</td>
          <td class="paramname"><em>newMessage</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>copy a new message content if its value is smaller than the current message content </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">newMessage</td><td>reference to the other messages </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a357e66838738d2e656066406920a0262"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename DATA_TYPE , typename ID_TYPE &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">uint_fast32_t <a class="el" href="classMessage.html">Message</a>&lt; DATA_TYPE, ID_TYPE &gt;::pack </td>
          <td>(</td>
          <td class="paramtype">uint8_t *&#160;</td>
          <td class="paramname"><em>buf</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>pack the content of the message to a uint8_t buffer. It is organized as : rcvr, sender, content </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">buf</td><td>a uint8_t buffer that will have the packed message </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>the size of the packed message in bytes. </dd></dl>

</div>
</div>
<a class="anchor" id="ab7355583d37391bd699f3fca47073281"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename DATA_TYPE , typename ID_TYPE &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classMessage.html">Message</a>&lt; DATA_TYPE, ID_TYPE &gt;::setContent </td>
          <td>(</td>
          <td class="paramtype">DATA_TYPE &amp;&#160;</td>
          <td class="paramname"><em>newContent</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>set the message content </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">newContent</td><td>the new message content </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a03cd1893fc75256c319cba7d850f0dcd"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename DATA_TYPE , typename ID_TYPE &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classMessage.html">Message</a>&lt; DATA_TYPE, ID_TYPE &gt;::setMessage </td>
          <td>(</td>
          <td class="paramtype">ID_TYPE &amp;&#160;</td>
          <td class="paramname"><em>tx</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">ID_TYPE &amp;&#160;</td>
          <td class="paramname"><em>rx</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">DATA_TYPE &amp;&#160;</td>
          <td class="paramname"><em>messContent</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>preparing the full message fields </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">tx</td><td>the sender vertex </td></tr>
    <tr><td class="paramname">rx</td><td>the receiver vertex </td></tr>
    <tr><td class="paramname">messContent</td><td>the message body </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a38c93c3a1da92bd20e0a8f166c30b6b7"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename DATA_TYPE , typename ID_TYPE &gt; </div>
<div class="memtemplate">
template&lt;typename CMessages &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classMessage.html">Message</a>&lt; DATA_TYPE, ID_TYPE &gt;::setMessage </td>
          <td>(</td>
          <td class="paramtype">CMessages &amp;&#160;</td>
          <td class="paramname"><em>newMessage</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>copy from another message </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">newMessage</td><td>reference to the other messages </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a3ddf04f2e6372501e0077170387d1723"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename DATA_TYPE , typename ID_TYPE &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classMessage.html">Message</a>&lt; DATA_TYPE, ID_TYPE &gt;::sumContent </td>
          <td>(</td>
          <td class="paramtype">DATA_TYPE &amp;&#160;</td>
          <td class="paramname"><em>newContent</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>sum new content to the current message content </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">newContent</td><td>the new message content (to be summed with the current message value) </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="ae23c04781f95e7c740d89861ebbca56d"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename DATA_TYPE , typename ID_TYPE &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">uint_fast32_t <a class="el" href="classMessage.html">Message</a>&lt; DATA_TYPE, ID_TYPE &gt;::unpack </td>
          <td>(</td>
          <td class="paramtype">uint8_t *&#160;</td>
          <td class="paramname"><em>buf</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>unpack a packed message to get the message </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">buf</td><td>a uint8_t buffer that has the packed message </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>the size of the packed message in bytes. </dd></dl>

</div>
</div>
<h2 class="groupheader">Member Data Documentation</h2>
<a class="anchor" id="a9f969486b4146319e66d95ebbdbe9dae"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename DATA_TYPE , typename ID_TYPE  = uint_fast32_t&gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">DATA_TYPE <a class="el" href="classMessage.html">Message</a>&lt; DATA_TYPE, ID_TYPE &gt;::content</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">protected</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">the</td><td>message body </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a1e01d44a1fcd11eeeeb2166b8f772708"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename DATA_TYPE , typename ID_TYPE  = uint_fast32_t&gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">ID_TYPE <a class="el" href="classMessage.html">Message</a>&lt; DATA_TYPE, ID_TYPE &gt;::rcvr</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">protected</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">the</td><td>receiver vertex </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a38d01ce6162b8e6ecf2dab14f0d72e5b"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename DATA_TYPE , typename ID_TYPE  = uint_fast32_t&gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">ID_TYPE <a class="el" href="classMessage.html">Message</a>&lt; DATA_TYPE, ID_TYPE &gt;::sender</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">protected</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">the</td><td>sender vertex </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<hr/>The documentation for this class was generated from the following files:<ul>
<li>/home/mohamed/code/tigl/src/common/api/<a class="el" href="tiglAPIMessage_8hpp_source.html">tiglAPIMessage.hpp</a></li>
<li>/home/mohamed/code/tigl/src/common/implementation/<a class="el" href="tiglImplementationMessage_8hpp_source.html">tiglImplementationMessage.hpp</a></li>
</ul>
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated on Tue Mar 3 2015 18:10:44 for TI  Graph Library   (TIGL) by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.7
</small></address>
</body>
</html>
